<?php
/*
Platobny modul pre VUB banku verzia 2.0

Copyright: 
(c) 2007 Daniel <medodrni@mail.t-com.sk>,
(c) 2005 Roman Hanajik <hanajik@dobryobchod.com>, 
(c) 2002 Jindrich Kratochvil (author Tatrapay module), www.oscommerce.com 
( modules api ) all rights reserved. Thanks to Drakeman.
Posledna uprava 24.1.2007

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

  1.Redistributions of source code must retain the above copyright notice,
    this list of conditions and the following disclaimer.
  2.Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the distribution.
  3.The name of the author may not be used to endorse or promote products
    derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN
NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. */

require_once 'includes/configure.php';

  class VUBPay extends base {
    var $code, $title, $description, $enabled;

    function VUBPay() {
      $this->code = 'VUBPay';
      $this->title = MODULE_PAYMENT_VUB_TEXT_TITLE;
      $this->description = MODULE_PAYMENT_VUB_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_PAYMENT_VUB_SORT_ORDER;
      $this->email_footer = MODULE_PAYMENT_VUB_TEXT_EMAIL_FOOTER;
      $this->enabled = MODULE_PAYMENT_VUB_STATUS;
      
			if ((int)MODULE_PAYMENT_VUB_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_VUB_ORDER_STATUS_ID;
      }

      if (is_object($order)) $this->update_status();
    }

// class methods
    function update_status() {
      global $order, $db;

      if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_COD_ZONE > 0) ) {
        $check_flag = false;
        $check = $db->Execute("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_COD_ZONE . "' and zone_country_id = '" . $order->delivery['country']['id'] . "' order by zone_id");
        while (!$check->EOF) {
          if ($check->fields['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check->fields['zone_id'] == $order->delivery['zone_id']) {
            $check_flag = true;
            break;
          }
          $check->MoveNext();
        }

        if ($check_flag == false) {
          $this->enabled = false;
        }
      }
    }

////
// Get url
    function get_url() {
        if (ENABLE_SSL_ADMIN == 'true') {
          $link = HTTPS_SERVER . DIR_WS_HTTPS_CATALOG . 'redirect_to_payment.php';
        } else {
          $link = HTTP_SERVER . DIR_WS_CATALOG . 'redirect_to_payment.php';
        }
        
        return $link;
    }

    function javascript_validation() {
    }

    function selection() {
      return array('id' => $this->code,
                   'module' => $this->title);
    }

    function pre_confirmation_check() {
      return false;
    }

    function confirmation() {
    }

    function process_button() {
      global $order, $db;

      $AMT = str_replace(".",",",number_format($order->info['total'], 2));
      $variab = $_SESSION['customer_id'];
      $variab .= date ("dmy");
      $url = 'https://www.vub.sk/ibank/e-platby.asp';
      $url_params = $AMT . '=' . $variab . '=' . MODULE_PAYMENT_VUB_SHOP_ID;
      
      if (MODULE_PAYMENT_VUB_SS != '')
          $process_string .= '=' . MODULE_PAYMENT_VUB_SS;
      $process_button_string = '<a href="' . $this->get_url() . '" target="_blank">' . MODULE_PAYMENT_VUB_TEXT_INFORMATION . '</a>&nbsp;
			<SCRIPT LANGUAGE="javascript">
			window.open(\'' . $url . '?' . $url_params .
			'\', null, "scrollbars=1, resizable=1, location=0, menubar=0, status=1, toolbar=0", true);
			</SCRIPT>';
      return $process_button_string;
    }

    function before_process() {
      return false;
    }

    function after_process() {
      //echo 'V novom okne VB internetovch platieb uhrate platbu. V opanom prpade Vaa objednvka nebude akceptovan';
      return false;
    }

    function output_error() {
      return false;
    }

    function check() {
      global $db;
      
      if (!isset($this->check)) {
        $check_query = $db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_VUB_STATUS'");
        $this->check = $check_query->RecordCount();
      }
      return $this->check;
    }

    function install() {
      global $db;
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Povoli VB platby', 'MODULE_PAYMENT_VUB_STATUS', 'True', 'Chcete povoli platby cez VBPay?', '6', '3', 'zen_cfg_select_option(array(\'True\', \'False\'), ', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('ID obchodu', 'MODULE_PAYMENT_VUB_SHOP_ID', 'obch1', 'Sem vlote ID obchodu, toto ID prideluje VB banka.', '6', '4', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('pecifick symbol', 'MODULE_PAYMENT_VUB_SS', '308', 'pecifick symbol - nepovinn parameter.', '6', '0', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Platobn zna', 'MODULE_PAYMENT_VUB_ZONE', '0', 'Ak je vybran zna, platba bude povolen len pre tto znu.', '6', '2', 'zen_get_zone_class_title', 'zen_cfg_pull_down_zone_classes(', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Poradie zobrazenia', 'MODULE_PAYMENT_VUB_SORT_ORDER', '0', 'Poradie zobrazenia. Najniie slo je zobrazen ako prv.', '6', '2', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Nastavi stav objednvok', 'MODULE_PAYMENT_VUB_ORDER_STATUS_ID', '0', 'Nastavi stav objednvok vytvorench tmto platobnm modulom na tto hodnotu.', '6', '0', 'zen_cfg_pull_down_order_statuses(', 'zen_get_order_status_name', now())");
    }

    function remove() {
      global $db;
      $db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_PAYMENT_VUB_STATUS', 'MODULE_PAYMENT_VUB_SHOP_ID', 'MODULE_PAYMENT_VUB_SS', 'MODULE_PAYMENT_VUB_ZONE', 'MODULE_PAYMENT_VUB_SORT_ORDER', 'MODULE_PAYMENT_VUB_ORDER_STATUS_ID');
    }
  }
?>
